/*
 *   EPRSD Intra task memory trace compression program
 *   Single Author info:
 *   sbudanu SANDEEP BUDANUR RAMANNA
 *
 */

#include<stdio.h>
#include "myprsdtlib.h"

#define TRACE_TAG 0xBEADBEAD


//#define INPUT_TRACE_FILE "/home/sbudanu/pin-2.5-24110-gcc.4.0.0-ia32_intel64-linux/source/tools/MyMemTrace/t1"
#define INPUT_TRACE_FILE "./STABLE/t1.txt"

/* example of deriving a class from abstract class INFO*/
class MYINFO:public INFO
{
	public:
	MYINFO():INFO()
	{
	}

	MYINFO(MYINFO& src):INFO()
	{
		//cout<<"\nMYINFO copy ctor called";
		value = src.value;
	}

	~MYINFO()
	{
		//cout <<"\nMYINFO dtor()";
	}

	virtual INT64 getValue()
	{
		//cout<<"\nMYINFO getValue called";
		return value;
	}
	virtual void setValue(void* val)
	{
		//cout<<"\nMYINFO setValue called";
		value = (INT64)val;
	}

};

FILE* fpipe = NULL;

/* class defining match function */
template <class T>
class MYMATCH
{
	public:
	inline static bool compare(T* src, T* dest)
	{
		//nothing to compare - return true
		//returning false makes all EPRSDs to be appended - uncompressed case
		return true;
	}
};

/* merge function hook */
template <class T>
class MYMERGE
{
	public:
	/* template library merges the EPRSDs, this is just a notification to user - is it really required?*/
	/* EPRSDs are private to compressor object, cannot let user merge them. Library merges the EPRSDs after
	matching the signature and userdefined part in MYMATCH::compare()
	*/
	inline static void mergecb(T* src, T* dest)
	{
		//cout<<endl<<"Merge_cb Src:"<<src->getValue()<<", "<<"Dest:"<<dest->getValue();
		return;
	}
};

#if 0
typedef struct TRACE
{
	UINT32 tag;
	UINT32 sign_len;
	UINT64* sign;
	UINT64 ref_id;
	UINT64 type;
	UINT32 thread_id;
	UINT32 node_id;
	UINT64 address;
}TRACE;
#endif

#if 0
/*function comparing two EPRSDs */
bool cmp_eprsd_fun(COMMON* cmn1, void* userinfo1, COMMON* cmn2, void* userinfo2)
{
	int i=0;
	//cout<<"\nCalling cmp function";
	//if reference id dono tmatch , return false
	if(cmn1->ref_id != cmn2->ref_id)
		return false;
	else //compare signature
	{
		if(cmn1->sign_len != cmn2->sign_len)
			return false;
		else
		{
			for(i=0;i<cmn1->sign_len;i++)
			{
				if(cmn1->signature[i] != cmn2->signature[i])
					return false;
			}
		}
	}
	return true;
}
#endif

int main()
{
        COMMON* cmn = NULL;
        MYINFO* address = NULL;
        int count = 20;
        int incr = 0;
        int res = 0, i = 0;
	UINT64 ip = 0;
	UINT64 ebp = 0;
	UINT64 sp = 0;
	UINT64 sign = 0;
	UINT64 tid = 0;
	char type;
	char valid;
	UINT64 addr = 0;
	UINT64 misc = 0;
	UINT64 *arr_sign = NULL;

        /* create a EPRSD compressor object of type MYINFO */
        EPRSD_COMPRESSOR<MYINFO, MYMATCH, MYMERGE> ecr1;
        EPRSD_COMPRESSOR<MYINFO, MYMATCH, MYMERGE>::ITERATOR iter(&ecr1);
	cmn = new COMMON(10);//sign len of 10 max
	address = new MYINFO();
	arr_sign = (UINT64*)malloc(10*sizeof(UINT64));


        #if 0
        /* add refID, address, threadid, nodeid etc. */
        while(count)
        {
                 incr = count%5;
                  /* user allocates memory for signature each time and library frees it in the end*/
                 cmn = new COMMON(NULL, 0, 0x1234+incr, 0x1001, 101, 10, "LD_ST");
                 address = new MYINFO(0xABCD9874+incr);
                 ecr1.add(cmn, address);
                 count--;
        }
        /* display all EPRSDs in the compressor object*/
         ecr1.print();
        #endif
        if((fpipe = fopen(INPUT_TRACE_FILE, "r"))== NULL)
        {
          printf("input file not present....exiting\n");
          exit(1);
        }

	#if 0
        while(1)
        {
	  	res = fread(&(t.tag), sizeof(UINT32), 1, fpipe);
		if(res < 1)
		{
			fprintf(stdout, "\nEOF/ERROR %d", res);
			break;
		}
		if(t.tag != TRACE_TAG)
		{
			fprintf(stdout, "\nInvalid tag");
			break;
		}
	  	res = fread(&(t.sign_len), sizeof(UINT32), 1, fpipe);
		t.sign = (UINT64*)malloc(t.sign_len * sizeof(UINT64));
		if(t.sign == NULL)
		{
			fprintf(stdout, "\nMalloc failed");
		}
		res = fread(t.sign, sizeof(UINT64), t.sign_len, fpipe);
	  	res = fread(&(t.ref_id), sizeof(UINT64), 1, fpipe);
	  	res = fread(&(t.type), sizeof(UINT64), 1, fpipe);
	  	res = fread(&(t.thread_id), sizeof(UINT32), 1, fpipe);
	  	res = fread(&(t.node_id), sizeof(UINT32), 1, fpipe);
	  	res = fread(&(t.address), sizeof(UINT64), 1, fpipe);
		//fprintf(stdout, "\nTAG: 0x%8X SIGN_LEN: %2d REF_ID: %16p ADDR: %16p TID: %3d NID: %3d TYPE: 0x%8X", \
				t.tag, t.sign_len, (void*)t.ref_id, (void*)t.address, t.thread_id, t.node_id, t.type);

		//fprintf(stdout, "\nsign: ");
		//for(i=0;i<t.sign_len;i++)
		//	fprintf(stdout, "%016p ", t.sign[i]);

                cmn = new COMMON(t.sign, t.sign_len, t.ref_id, t.type,
                      0x00000000FFFFFFFF & t.thread_id,
		      0x00000000FFFFFFFF & t.node_id,
		      "LD_ST");
                address = new MYINFO(t.address);
                ecr1.add(cmn, address);
        }
	#endif

	//fscanf
	while(1)
	{
		res = fscanf(fpipe,"ip:%20p ebp:%20p sp:%20p sign: %20p tid:%4u %c %c addr:%20p %u\n", \
                     &ip,     &ebp,     &sp,     &sign,      &tid, &type, &valid, &addr, &misc);


		if(res == EOF)
		{
			printf("EOF/ERROR");
			break;
		}
		else if(res == 0)
		{
			printf("Error reading");
			break;
		}

		//res = fprintf(stdout, "ip:%20p ebp:%20p sp:%20p sign: %20p tid:%4u %c %c addr:%20p %u\n",\
					ip, ebp, sp, sign, tid, type, valid, addr, misc);
                cmn->setData(NULL, 0, sign, type,
                      0x00000000FFFFFFFF & tid,
		      0x00000000FFFFFFFF & 0,
		      "LD_ST");
                address->setValue((void*)addr);
                ecr1.add(cmn, address);
	}

        /* display all EPRSDs in the compressor object*/
        //ecr1.print(stdout);
	ecr1.finalize();
	//printf("\nAfter finalize");
	//ecr1.print(stdout);
	printf("\nIterator test\n");
	iter.begin();
	EPRSD_DATA<MYINFO> *ptr;
	while(1)
	{
		ptr = iter.getNext();
		if(!ptr) break;
		printf("\n%p, code: %d, len: %d", ptr, ptr->code, (ptr->det[0]).length);
	}

        printf("\n");
        return 0;
}

